RealEstateNews/Areas/Admin/Controllers/DashboardController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using AutoMapper;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using RealEstateNews.Areas.Admin.Models;
using RealEstateNews.Entities;
using RealEstateNews.Models;
using RealEstateNews.Repositories;

namespace RealEstateNews.Areas.Admin.Controllers
{
    public class DashboardController : AdminBaseController
    {
        private readonly SignInManager<IdentityUser> _signInManager;
        private readonly UserManager<IdentityUser> _userManager;
        private readonly RoleManager<IdentityRole> _roleManager;
        private readonly RealEstateNewsContext _context;
        private readonly IMapper _mapper;

        public DashboardController(RealEstateNewsContext context, RoleManager<IdentityRole> roleManager, SignInManager<IdentityUser> signInManager, UserManager<IdentityUser> userManager, IMapper mapper)
        {
            _signInManager = signInManager;
            _userManager = userManager;
            _roleManager = roleManager;
            _context = context;
            _mapper = mapper;
        }

        public IActionResult Index()
        {
            var vm = new DashboardVM
            {
                NumberOfUsers = _context.Users.Count(),
                NumberOfPosts = _context.Posts.Count(),
                NumberOfCategories = _context.Categories.Count()
            };
            return View(vm);
        }

        public IActionResult AddUser()
        {
            return PartialView("_UserDetail", new UserDetailVM());
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddUser(UserDetailVM model)
        {
            var user = await _userManager.FindByNameAsync(model.UserName);
            if (user == null)
            {
                user = new IdentityUser { UserName = model.UserName };
                var userResult = await _userManager.CreateAsync(user, model.Password);
                if (userResult.Succeeded)
                {
                    await _userManager.AddToRoleAsync(user, model.Role.ToString());
                }
            }

            TempData["Success"] = "Create new user successfully!";
            return new JsonResult(null);
        }

        public IActionResult AddCategory()
        {
            return PartialView("_CategoryDetail");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddCategory(CategoryVM model)
        {
            var category = _mapper.Map<Category>(model);
            _context.Categories.Add(category);
            await _context.SaveChangesAsync();

            TempData["Success"] = "Create new category successfully!";
            return new JsonResult(null);
        }

        public IActionResult CreatePost()
        {
            var postVM = new PostVM
            {
                Categories = new Microsoft.AspNetCore.Mvc.Rendering.SelectList(_context.Categories.Select(i => new { Text = i.Name, Value = i.Id}), "Value", "Text")
            };
            return View("PostDetail", postVM);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> CreatePost(PostVM model)
        {
            if (!ModelState.IsValid)
            {
                return View("PostDetail", model);
            }

            Post post = new Post();
            if(model.Id > 0)
            {
                post = _context.Posts.First(p => p.Id == model.Id);
            }
            _mapper.Map(model, post);
            if (post.Id == 0)
            {
                post.CreatedDate = DateTime.Now;
                post.CreatedBy = _userManager.GetUserId(User);
            }
            else
            {
                post.UpdatedDate = DateTime.Now;
                post.UpdatedBy = _userManager.GetUserId(User);
            }

            if(model.CoverImage!= null && model.CoverImage.Length > 0)
            {
                string WebRoot = $"{Directory.GetCurrentDirectory()}{@"\wwwroot\images"}";
                var splits = Path.GetFileName(model.CoverImage.FileName).Split('.');
                var extension = splits[splits.Length - 1].ToLower();
                var fileName = $"{Guid.NewGuid()}.{extension}";

                using (var stream = new FileStream(Path.Combine(WebRoot, fileName), FileMode.Create))
                {
                    await model.CoverImage.CopyToAsync(stream);
                }
                post.ImageUrl = fileName;
            }

            _context.Entry(post).State = post.Id == 0 ? Microsoft.EntityFrameworkCore.EntityState.Added : Microsoft.EntityFrameworkCore.EntityState.Modified;
            await _context.SaveChangesAsync();

            return RedirectToAction("Index");
        }

        public IActionResult Posts()
        {
            var posts = _context.Posts.OrderByDescending(x => x.CreatedDate).Select(p => _mapper.Map<PostVM>(p)).ToList();
            return View(posts);
        }

        public IActionResult EditPost(int id)
        {
            var postVM = _context.Posts.Where(p => p.Id == id).Select(p => _mapper.Map<PostVM>(p)).FirstOrDefault();
            postVM.Categories = new Microsoft.AspNetCore.Mvc.Rendering.SelectList(_context.Categories.Select(i => new { Text = i.Name, Value = i.Id }), "Value", "Text");
            return View("PostDetail", postVM);
        }
    }
}

RealEstateNews/Controllers/PostController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using RealEstateNews.Models;
using RealEstateNews.Repositories;

namespace RealEstateNews.Controllers
{
    public class PostController : Controller
    {
        private readonly RealEstateNewsContext _context;
        private readonly IMapper _mapper;

        public PostController(RealEstateNewsContext context, IMapper mapper)
        {
            _context = context;
            _mapper = mapper;
        }

        public IActionResult Index(int id)
        {
            var post = _context.Posts.Where(p => p.Id == id).Select(t => _mapper.Map<PostVM>(t)).FirstOrDefault();
            return View(post);
        }

        public IActionResult Categories()
        {
            return PartialView("_Categories", _context.Categories.Select(c => _mapper.Map<CategoryVM>(c)).ToList());
        }

        public IActionResult Category(int id)
        {
            return View();
        }
    }
}

RealEstateNews/Views/Shared/_Categories.cshtml
@model IEnumerable<RealEstateNews.Models.CategoryVM>

<div class="card my-4">
    <h5 class="card-header">Categories</h5>
    <div class="card-body">
        <div class="row">
            <div class="col-lg-6">
                <ul class="list-unstyled mb-0">
                    <li>
                        <a href="#">Web Design</a>
                    </li>
                    <li>
                        <a href="#">HTML</a>
                    </li>
                    <li>
                        <a href="#">Freebies</a>
                    </li>
                </ul>
            </div>
            <div class="col-lg-6">
                <ul class="list-unstyled mb-0">
                    <li>
                        <a href="#">JavaScript</a>
                    </li>
                    <li>
                        <a href="#">CSS</a>
                    </li>
                    <li>
                        <a href="#">Tutorials</a>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</div>

RealEstateNews/Views/Shared/_FixFooter.cshtml
<style>

@@media screen and (min-width: 768px) {
    footer.fixedFooter {
        position: fixed;
        left: 0;
        bottom: 0;
        width: 100%;
        background-color: red;
        color: white;
        text-align: center;
    }
}
</style>

RealEstateNews/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - RealEstateNews</title>

    <environment include="Development">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.0.13/css/all.css" integrity="sha384-DNOHZ68U8hZfKXOrtjWvjxusGo9WQnrNx2sqG0tfsghAvtVlRW3tvkXWZh58N9jp"
        crossorigin="anonymous">        
        <link rel="stylesheet" href="~/lib/twitter-bootstrap/css/bootstrap.css" />
        <link href="~/lib/toastr.js/toastr.min.css" rel="stylesheet" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.0.13/css/all.css" integrity="sha384-DNOHZ68U8hZfKXOrtjWvjxusGo9WQnrNx2sqG0tfsghAvtVlRW3tvkXWZh58N9jp"
              crossorigin="anonymous">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous"
              asp-fallback-href="~/lib/twitter-bootstrap/css/bootstrap.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link href="~/lib/toastr.js/toastr.min.css" rel="stylesheet" />
        <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    </environment>
</head>
<body>
    <partial name="_Nav"/>

    <div class="body-content pt-4">
        @RenderBody()
    </div>

    <footer id="main-footer" class="bg-dark text-white mt-5 p-5 fixedFooter">
        <div class="container">
            <div class="row">
                <div class="col">
                    <p class="lead text-center">
                        Copyright ©
                        <span id="year">2018</span>
                        Real Estate News
                    </p>
                </div>
            </div>
        </div>
    </footer>


    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/popper.js/umd/popper.js"></script>
        <script src="~/lib/twitter-bootstrap/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
        <script src="~/lib/jquery-validate/jquery.validate.min.js"></script>
        <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"></script>
        <script src="~/lib/toastr.js/toastr.min.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-3.3.1.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-tsQFqpEReu7ZLhBV2VZlAu7zcOV+rXbYlF2cqB8txI/8aZajjp4Bqd+V6D5IgvKT">
        </script>
        <script src="~/lib/popper.js/umd/popper.js"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
        <script src="~/lib/jquery-validate/jquery.validate.min.js"></script>
        <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"></script>
        <script src="~/lib/toastr.js/toastr.min.js"></script>
    </environment>

    @RenderSection("Scripts", required: false)
    <partial name="_ModalDialog" />
    <partial name="_Toast" />
</body>
</html>

RealEstateNews/Views/Shared/_LoginInfo.cshtml
@using Microsoft.AspNetCore.Identity

@inject SignInManager<IdentityUser> SignInManager

@if (SignInManager.IsSignedIn(User))
{
    var isAdmin = User.IsInRole(EnumRole.Admin.ToString());
    <form class="form-inline" id="frmLogout" asp-action="Logout" asp-area="" asp-controller="Account" method="post">
        <ul class="navbar-nav">
            <li class="nav-item">
                <a class="nav-link" href="javascript:void()">Welcome @User.Identity.Name</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="javascript:{}" onclick="document.getElementById('frmLogout').submit();">
                    <i class="fas fa-user-times"></i> Logout
                </a>
            </li>
        </ul>
    </form>
}
else
{
    <ul class="navbar-nav">
        <li class="nav-item">
            <a class="nav-link" asp-action="Login" asp-controller="Account">Login</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" asp-controller="Account" asp-action="Register">Register</a>
        </li>
    </ul>
}

RealEstateNews/Views/Shared/_ModalDialog.cshtml
<!-- Modal -->
<div class="modal fade" id="modalDialog" tabindex="-1" role="dialog" aria-labelledby="modalTitle" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="modalTitle"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="button" data-save="modal" class="btn btn-primary">Save changes</button>
            </div>
        </div>
    </div>
</div>

RealEstateNews/Views/Shared/_Nav.cshtml
@{ 
    var isAdmin = User.Identity.IsAuthenticated && User.IsInRole(EnumRole.Admin.ToString());
}

<nav class="navbar fixed-top navbar-expand-md navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" asp-area="" asp-action="Index" asp-controller="Home"><i class="fas fa-home"></i>&nbsp;Real Estate News</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item">
                        <a class="nav-link" asp-action="Index" asp-controller="Home" asp-area="">Posts</a>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Categories
                        </a>
                        @await Component.InvokeAsync("CategoryMenuComponent")
                    </li>
                    @if (isAdmin)
                    {
                        <li class="nav-item">
                            <a class="nav-link" asp-action="Index" asp-controller="Dashboard" asp-area="Admin">Admin Dashboard</a>
                        </li>
                    }
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Content("~/AboutUs")">About Us</a>
                    </li>
                </ul>
                <partial name="_LoginInfo" />
            </div>
        </div>
    </nav>

RealEstateNews/Views/Shared/_PostItem.cshtml
@model RealEstateNews.Models.PostVM
<div class="card border-top-0 border-right-0 border-left-0 rounded-0">
    <div class="row no-gutters">
        <div class="col-auto">
            <img width="200" height="200" src="@Url.Content($"~/images/{Model.ImageUrl}")" class="img-fluid" alt="">
        </div>
        <div class="col">
            <div class="card-block p-2">
                <a asp-action="Index" asp-controller="Post" asp-route-id="@Model.Id" asp-route-slug="@Model.Title.GenerateSlug()" class="text-dark"><h5 class="card-title">@Model.Title</h5></a>
                <p class="card-text">@Html.Raw(Model.Body.SubStringUntilLastWord(200))</p>
            </div>
        </div>
    </div>
</div>

RealEstateNews/Views/Shared/_Toast.cshtml
@{ 
    if(TempData["Success"] != null)
    {
        <script>
            $(document).ready(function () {
                toastr.success('@TempData["Success"]');
            });
        </script>
    }
}